      SUBROUTINE REM (M,N,C,XI,E,Y,AL,SUM,B,IN)                         00010000
CC                                                                      00020000
CC        PROLATE RADIAL FUNCTION OF THE SECOND KIND BY THE INTEGRAL    00030000
CC        METHOD OF SINHA & MACPHIE (1975).                             00040000
CC         C = REAL    :    CALCULATION - REAL*8                        00050000
CC         REQUIRED SUBPROGRAMMS : RFCT, DGAUSL                         00060000
CC      ------------------------- PROGRAMMED IN 1977 ----------------   00070000
      IMPLICIT REAL*8(A-H,O-Z)                                          00080000
      EXTERNAL  RFCT                                                    00090000
      COMMON  /R2INTR/D(6),CF,MMM,NNN                                   00100000
      DIMENSION H(6),G(6),F(6),BT(6)                                    00110000
C                                                                       00111000
      MMM=M                                                             00120000
      NNN=N                                                             00130000
      HH=(4*M*M-1)*C*C                                                  00140000
      MM=M*M                                                            00150000
      U=4*E-2*C*C                                                       00160000
      UU= U*U                                                           00170003
      F(1)=2.*(M-1)                                                     00180000
      F(2)=(U+(4*MM-28.*M+24.))/4.                                      00190000
      F(3)=((4*M-14.)*U-(40*MM-184*M+144.))/8.                          00200000
      F(4)=(UU+(4*MM-68.*M+140.)*U+2.*HH+(304*MM-1168.*M+864))/16.      00210003
      F(5)=((4*M-24)*UU-(80*MM-768.*M+1208.)*U+(8*M-48.)*HH-(2080*MM    00220000
     +     -7264*M+5184.))/32.                                          00230004
      F(6)=(UU*U+(4*MM-108.*M+356.)*UU+(1008*MM-7216.*M+9584)*U         00240003
     +     +4.*U*HH+(8*MM-216.*M+718)*HH+(13504*MM-44608*M+31104))/64.  00250000
      W=C*C*XI*XI/2.                                                    00260000
      WW=W*W                                                            00270003
         IF (IN.EQ.1)  THEN                                             00280003
      G(1)=2.                                                           00290000
      G(2)=-W-2.                                                        00300000
      G(3)=3*W+2                                                        00310000
      G(4)=-(WW+19*W+8.)/4.                                             00320000
      G(5)=(24*WW+56*W+16.)/8.                                          00330000
      G(6)=-(4*W**3+62*WW+153*W+32.)/16.                                00340000
         ELSE                                                           00350003
      G(1)=0.                                                           00360003
      G(2)=-W                                                           00370003
      G(3)=W                                                            00380003
      G(4)=-(WW+7*W)/4.                                                 00390003
      G(5)=-(4*WW-20*W)/8.                                              00400003
      G(6)=-(4*WW*W+14*WW+61*W)/16.                                     00410003
         END IF                                                         00420003
    7 CONTINUE                                                          00430000
      AL=DLOG(XI)                                                       00440000
      DO 12 I=1,6                                                       00450000
      H(I)=F(I)+G(I)                                                    00460000
      I1=I-1                                                            00470000
      IF (I1.EQ.0) GO TO 12                                             00480000
      DO 10 L=1,I1                                                      00490000
      H(I)=H(I)+F(L)*G(I-L)                                             00500000
   10 CONTINUE                                                          00510000
   12 CONTINUE                                                          00520000
      B=H(1)/2.                                                         00530000
      BT(1)=B*(B-1)                                                     00540000
      DO 20 I=2,5                                                       00550000
      BT(I)=BT(I-1)*(B-I)                                               00560000
   20 CONTINUE                                                          00570000
      D(1)=(2*BT(1)-H(2))/2.                                            00580000
       D11=D(1)*D(1)                                                    00590003
      D(2)=(4*BT(2)/3.-4*B*D(1)+4*D(1)-H(3))/4.                         00600000
       D22=D(2)*D(2)                                                    00610003
      D(3)=(2*BT(3)/3.-4*BT(1)*D(1)+8*B*(D(1)-D(2))-(8*D(1)-2*D11-12    00620003
     1 *D(2))-H(4))/6.                                                  00630000
      D(4)=(4*BT(4)/15.-8*BT(2)*D(1)/3.+8*BT(1)*(D(1)-D(2))-2*B*(8*D(1) 00640000
     1 -2*D11-12*D(2)+6*D(3))+                                          00650003
     2 (16*D(1)-8*D11+8*D(1)*D(2)-32*D(2)+24*D(3))-H(5))/8.             00660003
      D(5)=(4*BT(5)/45.-4*BT(3)*D(1)/3.+16*BT(2)/3.*(D(1)-D(2))         00670000
     1 -2*BT(1)*(8*D(1)-2*D11-12*D(2)+6*D(3))                           00680003
     2 +2*B*(16*D(1)-8*D11+8*D(1)*D(2)-32*D(2)+24*D(3)-8*D(4))          00690003
     3 -(32*D(1)-24*D11+40*D(1)*D(2)-80*D(2)-8*D22                      00700003
     4 -12*D(1)*D(3)+80*D(3)-40*D(4)+4.*D11/3.)-H(6))/10.               00710003
      SUM=0.                                                            00720000
      DO 15 K=1,5                                                       00730000
      SUM=SUM+D(K)/(M+N)**K                                             00740000
   15 CONTINUE                                                          00750000
      CF=AL                                                             00760000
      D(6)=B                                                            00770000
       Y=DGAUSL(RFCT,5)                                                 00780003
      RETURN                                                            00790000
      END                                                               00800000
